// #include "../parser.h"
// #include "../type.h"

// enum TypeParseState {
//     TPS_BASE_TYPE,    // 解析基础类型 (int/char等)
//     TPS_QUALIFIER,    // 解析限定符 (const/volatile)
//     TPS_POINTER,      // 解析指针 (*)
//     TPS_ARRAY,        // 解析数组维度 ([n])
//     TPS_FUNC_PARAMS   // 解析函数参数列表
// };

// ast_node_t* parse_type(parser_t* p) {
//     ast_node_t* type_root = new_ast_node();
//     ast_node_t* current = type_root;
//     current->type = NT_TYPE_BASE;

//     enum TypeParseState state = TPS_QUALIFIER;
//     int pointer_level = 0;

//     while (1) {
//         tok_type_t t = peektoktype(p);
        
//         switch (state) {
//         // 基础类型解析 (int, char等)
//         case TPS_BASE_TYPE:
//             if (is_base_type(t)) {
//                 // current->data.data_type = token_to_datatype(t);
//                 pop_tok(p);
//                 state = TPS_POINTER;
//             } else {
//                 error("Expected type specifier");
//             }
//             break;

//         // 类型限定符 (const/volatile)
//         case TPS_QUALIFIER:
//             if (t == TOKEN_CONST || t == TOKEN_VOLATILE) {
//                 ast_node_t* qual_node = new_ast_node();
//                 qual_node->type = NT_TYPE_QUAL;
//                 qual_node->data.data_type = t; // 复用data_type字段存储限定符
//                 current->child.decl.type = qual_node;
//                 current = qual_node;
//                 pop_tok(p);
//             } else {
//                 state = TPS_BASE_TYPE;
//             }
//             break;

//         // 指针解析 (*)
//         case TPS_POINTER:
//             if (t == TOKEN_MUL) {
//                 ast_node_t* ptr_node = new_ast_node();
//                 ptr_node->type = NT_TYPE_PTR;
//                 current->child.decl.type = ptr_node;
//                 current = ptr_node;
//                 pointer_level++;
//                 pop_tok(p);
//             } else {
//                 state = TPS_ARRAY;
//             }
//             break;

//         // 数组维度 ([n])
//         case TPS_ARRAY:
//             if (t == TOKEN_L_BRACKET) {
//                 pop_tok(p); // 吃掉[
//                 ast_node_t* arr_node = new_ast_node();
//                 arr_node->type = NT_TYPE_ARRAY;
                
//                 // 解析数组大小（仅语法检查）
//                 if (peektoktype(p) != TOKEN_R_BRACKET) {
//                     parse_expr(p); // 不计算实际值
//                 }
                
//                 expecttok(p, TOKEN_R_BRACKET);
//                 current->child.decl.type = arr_node;
//                 current = arr_node;
//             } else {
//                 state = TPS_FUNC_PARAMS;
//             }
//             break;

//         // 函数参数列表
//         case TPS_FUNC_PARAMS:
//             if (t == TOKEN_L_PAREN) {
//                 ast_node_t* func_node = new_ast_node();
//                 func_node->type = NT_TYPE_FUNC;
//                 current->child.decl.type = func_node;
                
//                 // 解析参数列表（仅结构，不验证类型）
//                 parse_param_list(p, func_node);
//                 current = func_node;
//             } else {
//                 return type_root; // 类型解析结束
//             }
//             break;
//         }
//     }
// }

// // 判断是否是基础类型
// static int is_base_type(tok_type_t t) {
//     return t >= TOKEN_VOID && t <= TOKEN_DOUBLE;
// }

// // // 转换token到数据类型（简化版）
// // static enum DataType token_to_datatype(tok_type_t t) {
// //     static enum DataType map[] = {
// //         [TOKEN_VOID] = DT_VOID,
// //         [TOKEN_CHAR] = DT_CHAR,
// //         [TOKEN_INT] = DT_INT,
// //         // ...其他类型映射
// //     };
// //     return map[t];
// // }

// // 解析参数列表（轻量级）
// static void parse_param_list(parser_t* p, ast_node_t* func) {
//     expecttok(p, TOKEN_L_PAREN);
    
//     while (peektoktype(p) != TOKEN_R_PAREN) {
//         ast_node_t* param = parse_type(p); // 递归解析类型
        
//         // 允许可选参数名（仅语法检查）
//         if (peektoktype(p) == TOKEN_IDENT) {
//             pop_tok(p); // 吃掉参数名
//         }
        
//         if (peektoktype(p) == TOKEN_COMMA) {
//             pop_tok(p);
//         }
//     }
    
//     expecttok(p, TOKEN_R_PAREN);
// }

