#ifndef __SMCC_RELOC_SYMTAB_H__
#define __SMCC_RELOC_SYMTAB_H__
// Relocation Symbol Table

#include <lib/core.h>
#include <lib/utils/ds/hashtable.h>

typedef enum reloc_attr {
    RELOC_ATTR_GLOBAL,
    RELOC_ATTR_LOCAL,
} reloc_attr_t;

typedef struct reloc_entry {
    const char* name;
    reloc_attr_t attr;
} reloc_entry_t;

typedef struct reloc_symtab {
    hash_table_t reloctab;
} reloc_symtab_t;

void init_symtab_asm(reloc_symtab_t* symtab);
void symtab_asm_put(reloc_symtab_t* symtab, reloc_entry_t* entry, u32_t address);
u32_t* symtab_asm_get(reloc_symtab_t* symtab, reloc_entry_t* entry);
void symtab_asm_destroy(reloc_symtab_t* symtab);

#endif
