#ifndef __SMCC_ASM_RISCV32_H__
#define __SMCC_ASM_RISCV32_H__

#include <lib/core.h>
#include <lib/utils/ds/vector.h>
#include "riscv32_def.h"

typedef struct rotated_instr {
    u32_t pos;
    void* target;
    rv32_instr_t instr;
} rotated_instr_t;

typedef struct mcode_rv32 {
    VECTOR_HEADER(rinstrs, rotated_instr_t);
    VECTOR_HEADER(code, u8_t);
    int target_size;
} mcode_rv32_t;

void init_rv32_mcode(mcode_rv32_t* mcode, int target_size);
int emit_rv32_instr(mcode_rv32_t* mcode, rv32_instr_t *instr, u32_t idx, void *target);

#endif
